/*
 * SPI_Test_Defs.h
 *
 *  Created on: Jun 26, 2015
 *      Author: RK
 */

#ifndef SPI_TEST_DEFS_H_
#define SPI_TEST_DEFS_H_

#define BIT7 0x80
#define BIT6 0x40
#define BIT5 0x20
#define BIT4 0x10
#define BIT3 0x08
#define BIT2 0x04
#define BIT1 0x02
#define BIT0 0x01

#define HIGH 1
#define LOW 0

#define TRUE 1
#define FALSE 0

#define LINE_NUM_BYTES 18
#define LCD_NUM_LINES 128

#define IDLE 0
#define SING_LINE_WRITEMODE_SENT 1
#define SING_LINE_ADDR_SENT 2
#define SING_LINE_TX_DONE 3
#define ALL_CLEAR_SENT 4
#define FIRST_ALLCLEAR_DUMMY_SENT 5
#define SECOND_ALLCLEAR_DUMMY_SENT 6

//global variables shared across files
extern bit SEND_NEXT_LINE_FLAG;
extern unsigned char Scroll_LineNum;
extern code unsigned char LCDLineAddr_LUT[];
extern unsigned char LCDTxState;
extern unsigned char LCDLineAddress;
extern unsigned char LCDLineData[];

//function prototypes
void WriteLCDLine(unsigned char LineAddress);
void LCDAllClear();
void InitLCD();
void Fill_LineData_White();
void Fill_LineData_Black();

//port pins
sbit RGBLED_G = P1^4;
sbit RGBLED_B = P1^5;
sbit RGBLED_R = P1^6;

sbit SPI_CS = P0^1;

#endif /* SPI_TEST_DEFS_H_ */
